#include "bstar.h"
#include "settings.h"

const int bstar::p = 4;
double bstar::calc(complex <double> b, double blim)
{
  double bs = 0.;
  if (opts.fbstar == 0)
    bs = real(b)/sqrt(1.+pow(real(b)/blim,2));

  //Eq. (23) of  https://arxiv.org/pdf/1703.10157.pdf  (or 2.35 of https://arxiv.org/pdf/1912.07550.pdf)
  if (opts.fbstar == 1)
    if (pow(real(b)/blim,p) < 1e-12)
      bs = real(b);
    else
      bs = blim*pow(1.-exp(-pow(real(b)/blim,p)),1./p);

  return bs;
}

double bstar::inv(complex <double> bstar, double blim)
{
  double b;
  if (opts.fbstar == 0)
    b = sqrt(1./(1./pow(real(bstar),2)-1./pow(blim,2)));

  if (opts.fbstar == 1)
    b = blim*pow(log(1.-pow(real(bstar)/blim,p)),1./p);

  return b;
}
