#include "muf.h"
#include "resint.h"
#include "pmom.h"
#include "mesq.h"
#include "settings.h"
#include "ccoeff.h"
#include "resconst.h"

using namespace pmom;
using namespace resconst;
using namespace ccoeff;

complex <double> muf::h4st_qbq   (int idx ) {return + pow(gamma2qqb[idx],2)*LF2+ pow(gamma2qqb[idx],2)*LQ2- 2.*pow(gamma2qqb[idx],2)*LQ*LF+ gamma1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LF3- gamma1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ3+ 3.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ2*LF- 3.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ*LF2+ 1./4.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LF4+ 1./4.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ4- pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ3*LF+ 3./2.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ2*LF2- pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ*LF3+ 2.*EC1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LF2+ 2.*EC1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ2 - 4.*EC1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ*LF+ EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3- EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+ 3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF- 3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2+ pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LF2+ pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LQ2- 2.*pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LQ*LF+ 2.*EC2qqb[idx]*gamma2qqb[idx]*LF- 2.*EC2qqb[idx]*gamma2qqb[idx]*LQ+ EC2qqb[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ EC2qqb[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- 2.*EC2qqb[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ 2.*EC2qqb[idx]*EC1qg[idx]*gamma1gq[idx]*LF- 2.*EC2qqb[idx]*EC1qg[idx]*gamma1gq[idx]*LQ ;}
complex <double> muf::h4st_qbqp  (int idx ) {return + gamma2qqb[idx]*gamma2qqbp[idx]*LF2+ gamma2qqb[idx]*gamma2qqbp[idx]*LQ2- 2.*gamma2qqb[idx]*gamma2qqbp[idx]*LQ*LF+ 1./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LF3- 1./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ3+ 3./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ2*LF- 3./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ*LF2+ 1./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LF3- 1./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ3+ 3./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ2*LF- 3./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ*LF2+ 1./4.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LF4+ 1./4.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ4- pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ3*LF + 3./2.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ2* LF2- pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ*LF3+ EC1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LF2+ EC1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ2- 2.*EC1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ*LF+ EC1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LF2+ EC1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ2- 2.*EC1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ*LF+ EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3- EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+ 3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF- 3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2+ pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LF2+ pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LQ2 - 2.*pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LQ*LF+ EC2qqbp[idx]*gamma2qqb[idx]*LF- EC2qqbp[idx]*gamma2qqb[idx]*LQ+ 1./2.*EC2qqbp[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ 1./2.*EC2qqbp[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- EC2qqbp[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ EC2qqbp[idx]*EC1qg[idx]*gamma1gq[idx]*LF- EC2qqbp[idx]*EC1qg[idx]*gamma1gq[idx]*LQ+ EC2qqb[idx]*gamma2qqbp[idx]*LF- EC2qqb[idx]*gamma2qqbp[idx]*LQ+ 1./2.*EC2qqb[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ 1./2.*EC2qqb[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- EC2qqb[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ EC2qqb[idx]*EC1qg[idx]*gamma1gq[idx]*LF- EC2qqb[idx]*EC1qg[idx]*gamma1gq[idx]*LQ ;}
complex <double> muf::h4st_qbqbp (int idx ) {return + gamma2qqb[idx]*gamma2qqp[idx]*LF2+ gamma2qqb[idx]*gamma2qqp[idx]*LQ2- 2.*gamma2qqb[idx]*gamma2qqp[idx]*LQ*LF+ 1./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LF3- 1./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ3+ 3./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ2*LF- 3./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ*LF2+ 1./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LF3- 1./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ3+ 3./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ2*LF- 3./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ*LF2+ 1./4.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LF4+ 1./4.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ4- pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ3*LF + 3./2.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ2* LF2- pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ*LF3+ EC1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LF2+ EC1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ2- 2.*EC1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ*LF+ EC1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LF2+ EC1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ2- 2.*EC1qg[idx]*gamma1gq[idx]*gamma2qqb[idx]*LQ*LF+ EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3- EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+ 3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF- 3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2+ pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LF2+ pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LQ2 - 2.*pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LQ*LF+ EC2qqp[idx]*gamma2qqb[idx]*LF- EC2qqp[idx]*gamma2qqb[idx]*LQ+ 1./2.*EC2qqp[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ 1./2.*EC2qqp[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- EC2qqp[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ EC2qqp[idx]*EC1qg[idx]*gamma1gq[idx]*LF- EC2qqp[idx]*EC1qg[idx]*gamma1gq[idx]*LQ+ EC2qqb[idx]*gamma2qqp[idx]*LF- EC2qqb[idx]*gamma2qqp[idx]*LQ+ 1./2.*EC2qqb[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ 1./2.*EC2qqb[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- EC2qqb[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ EC2qqb[idx]*EC1qg[idx]*gamma1gq[idx]*LF- EC2qqb[idx]*EC1qg[idx]*gamma1gq[idx]*LQ ;}
complex <double> muf::h4st_qpqp  (int idx ) {return + gamma2qqp[idx]*gamma2qqbp[idx]*LF2+ gamma2qqp[idx]*gamma2qqbp[idx]*LQ2- 2.*gamma2qqp[idx]*gamma2qqbp[idx]*LQ*LF+ 1./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LF3- 1./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ3+ 3./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ2*LF- 3./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ*LF2+ 1./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LF3- 1./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ3+ 3./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ2*LF- 3./2.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ*LF2+ 1./4.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LF4+ 1./4.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ4- pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ3*LF + 3./2.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ2* LF2- pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ*LF3+ EC1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LF2+ EC1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ2- 2.*EC1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ*LF+ EC1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LF2+ EC1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ2- 2.*EC1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ*LF+ EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3- EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+ 3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF- 3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2+ pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LF2+ pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LQ2 - 2.*pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LQ*LF+ EC2qqbp[idx]*gamma2qqp[idx]*LF- EC2qqbp[idx]*gamma2qqp[idx]*LQ+ 1./2.*EC2qqbp[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ 1./2.*EC2qqbp[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- EC2qqbp[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ EC2qqbp[idx]*EC1qg[idx]*gamma1gq[idx]*LF- EC2qqbp[idx]*EC1qg[idx]*gamma1gq[idx]*LQ+ EC2qqp[idx]*gamma2qqbp[idx]*LF- EC2qqp[idx]*gamma2qqbp[idx]*LQ+ 1./2.*EC2qqp[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ 1./2.*EC2qqp[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- EC2qqp[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ EC2qqp[idx]*EC1qg[idx]*gamma1gq[idx]*LF- EC2qqp[idx]*EC1qg[idx]*gamma1gq[idx]*LQ ;}
complex <double> muf::h4st_qpqbp (int idx ) {return + pow(gamma2qqp[idx],2)*LF2+ pow(gamma2qqp[idx],2)*LQ2- 2.*pow(gamma2qqp[idx],2)*LQ*LF+ gamma1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LF3- gamma1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ3+ 3.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ2*LF- 3.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ*LF2+ 1./4.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LF4+ 1./4.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ4- pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ3*LF+ 3./2.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ2*LF2- pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ*LF3+ 2.*EC1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LF2+ 2.*EC1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ2 - 4.*EC1qg[idx]*gamma1gq[idx]*gamma2qqp[idx]*LQ*LF+ EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3- EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+ 3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF- 3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2+ pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LF2+ pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LQ2- 2.*pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LQ*LF+ 2.*EC2qqp[idx]*gamma2qqp[idx]*LF- 2.*EC2qqp[idx]*gamma2qqp[idx]*LQ+ EC2qqp[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ EC2qqp[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- 2.*EC2qqp[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ 2.*EC2qqp[idx]*EC1qg[idx]*gamma1gq[idx]*LF- 2.*EC2qqp[idx]*EC1qg[idx]*gamma1gq[idx]*LQ ;}
complex <double> muf::h4st_qbpqp (int idx ) {return + pow(gamma2qqbp[idx],2)*LF2+ pow(gamma2qqbp[idx],2)*LQ2- 2.*pow(gamma2qqbp[idx],2)*LQ*LF+ gamma1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LF3- gamma1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ3+ 3.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ2*LF- 3.*gamma1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ*LF2+ 1./4.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LF4+ 1./4.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ4- pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ3*LF+ 3./2.*pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ2*LF2- pow(gamma1qg[idx],2)*pow(gamma1gq[idx],2)*LQ*LF3+ 2.*EC1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LF2+ 2.*EC1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ2 - 4.*EC1qg[idx]*gamma1gq[idx]*gamma2qqbp[idx]*LQ*LF+ EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LF3- EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ3+ 3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ2*LF- 3.*EC1qg[idx]*gamma1qg[idx]*pow(gamma1gq[idx],2)*LQ*LF2+ pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LF2+ pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LQ2- 2.*pow(EC1qg[idx],2)*pow(gamma1gq[idx],2)*LQ*LF+ 2.*EC2qqbp[idx]*gamma2qqbp[idx]*LF- 2.*EC2qqbp[idx]*gamma2qqbp[idx]*LQ+ EC2qqbp[idx]*gamma1qg[idx]*gamma1gq[idx]*LF2+ EC2qqbp[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ2- 2.*EC2qqbp[idx]*gamma1qg[idx]*gamma1gq[idx]*LQ*LF+ 2.*EC2qqbp[idx]*EC1qg[idx]*gamma1gq[idx]*LF- 2.*EC2qqbp[idx]*EC1qg[idx]*gamma1gq[idx]*LQ ;}
